package orchid.agent;

import orchid.object.*;
import java.util.*;
import java.io.*;
import com.objectspace.voyager.mobility.*;
import com.objectspace.voyager.*;
import com.objectspace.lib.*;
import com.objectspace.lib.util.*;
import com.objectspace.lib.facets.*;
import com.objectspace.voyager.agent.*;
import com.objectspace.voyager.space.*;
import com.objectspace.voyager.space.Subspace;

/**
	* Engine phase 01 for the MeetingAgent.
	* Launched in case of the agent is an Initiator of a meeting.
	*/
	public class MAEngine01 extends Thread
		{
			private Calendar endtime;
			private MeetingAgent father;
			private MeetingProposal meetp;
			private boolean taskachieved = false;
			private int rythm;

			public MAEngine01(MeetingAgent father, MeetingProposal meetp, Calendar endtime, int rythm)
				{
					this.endtime = endtime;
					this.father = father;
					this.meetp = meetp;
					this.rythm = rythm;
				}

			public void run()
				{
					Hashtable guestinfolist = meetp.getGuestInfoList();
					Enumeration e;
					int count=0;

					orchid.object.Util.logMsg("info","MA-Engine01 working on meeting "+meetp.getKey(),"MA-Engine01 launched");
					this.setPriority(MIN_PRIORITY);
					try
						{
							while (!taskachieved)
							{
								this.sleep(rythm);
								if (father.answerarrived)
									{
										count=0;
										guestinfolist = meetp.getGuestInfoList();
										e = guestinfolist.elements();
										while (e.hasMoreElements())
											if (((GuestInfo) e.nextElement()).getAnswer() != -1)
												count++;
										father.answerarrived = false;
									}
								taskachieved = ((Calendar.getInstance()).after(endtime)) || (count == guestinfolist.size());
							}
						} catch (InterruptedException ie1) {}
					/*
					 * Cleaning of the guest list to obtain a participant list
					 */
					Hashtable participantlist = new Hashtable();
					guestinfolist = meetp.getGuestInfoList();
					e = guestinfolist.elements();
					while (e.hasMoreElements())
						{
							GuestInfo guestinfo = (GuestInfo) e.nextElement();
							if (guestinfo.getAnswer() == 1)
								participantlist.put(guestinfo.getName(), guestinfo);
						}
					meetp.setParticipantList(participantlist);
					
					IMeetingAgent ma;
					Vector agentslist = father.getAgentsUrl(Util.enumToVector(meetp.getGuestInfoList().keys()));
					try 
						{
							for (int i = 0 ; i < agentslist.size() ; i++)
								{
									AgentInfo agcontacted = (AgentInfo) agentslist.elementAt(i);
									// This test avoid the initiator agent to call a new meeting on itself (optimization).
									if ( ! agcontacted.getName().equals("ma__"+meetp.getInitiator()) ) { 
										ma = (IMeetingAgent) Namespace.lookup("//"+agcontacted.getCurrentlocation()+"/"+agcontacted.getName());
										
										// Make the agents of the participants update their meetingProposalList 
										// with the newly updated meetingProposal containing the right participants
										ma.updateMeeting(meetp);
									}
								}
							// After updateMeeting is done, ask the SAA to create a subspace for everybody to send its CF
								try {
									ISaa saa = (ISaa) Namespace.lookup("//"+father.agent_user.getHome()+"/SAA");
									Vector participantAgentList = father.getAgentsUrl(Util.enumToVector(meetp.getGuestInfoList().keys()));
									Vector proxyNameList= new Vector( participantAgentList.size());;
									Enumeration e2 = participantAgentList.elements();
									while (e2.hasMoreElements())
										{
											AgentInfo agentelement = (AgentInfo) e2.nextElement();
											// This test is here to prevent to add the initiator agent to the new subspace.
											if ( ! agentelement.getName().equals("ma__"+meetp.getInitiator()) )
												proxyNameList.addElement("//"+agentelement.getCurrentlocation()+"/"+agentelement.getName());
										}

									saa.createSubspace("Room."+meetp.getInitiator(),proxyNameList);
								} catch(Exception ex2) {
									orchid.object.Util.logMsg("error","MAEngine01","Can't reach "+father.agent_user.getHome()+"/SAA "+ex2);
									}

						} catch(Exception ex) {
							//orchid.object.Util.logMsg("error","ma__"+father.agent_user.getName(),"Can't reach the "+((AgentInfo) agentslist.elementAt(i)).getName()+" >> "+ex);
						}

					try 
						{
							ISubspace meetingsubspace = (ISubspace) Namespace.lookup("//"+father.getCurrentlocation()+"/Room."+meetp.getInitiator());
							IMeetingAgent maofthemeeting = (IMeetingAgent) meetingsubspace.getMulticastProxy("orchid.agent.IMeetingAgent");
							maofthemeeting.startGivingCF(meetp.getKey());
						}
					catch (Exception exxx)
						{
							orchid.object.Util.logMsg("error","MA-Engine01 ("+meetp.getKey()+")","Unable to reach subspace Room."+meetp.getInitiator());
						}

					orchid.object.Util.logMsg("info","MA-Engine01 ("+father.agent_user.getName()+") working on meeting "+meetp.getKey(),"*** MA-Engine01 terminated ***\n");
				}
		}
