
package orchid.gui;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.BorderFactory; 
import javax.swing.border.TitledBorder;

/**
 * @author Marc-Aurle DARCHE
 */
public class AboutWindow extends JFrame {

	ImageIcon linux_Icon;
	Point loginWindowLocation;

	public AboutWindow(Point loginWindowLocation){
		super("About ORCHID");
		this.loginWindowLocation=loginWindowLocation;
	}

	public void init(){

		JLabel pureJava_IconLabel = new JLabel();
		Class me= this.getClass();
		String where="/orchid/img/";
		//String where="../img/"; should also work, but it's better to use the line above.
		//ImageIcon pureJava_Icon = new ImageIcon("orchid/gui/img/pureJava.gif"); this line is even worse
		ImageIcon pureJava_Icon = new ImageIcon(me.getResource(where+"pureJava.gif"));
		pureJava_IconLabel.setIcon(pureJava_Icon);

		JPanel pixPane = new JPanel();
		pixPane.setBackground(new Color(255,255,255));
		pixPane.add(pureJava_IconLabel);
	
		Font labelFont= new Font("SansSerif", Font.BOLD, 14);
		JLabel french_about_Label1 = new JLabel("Plate-forme de Tltravail", JLabel.CENTER);
		JLabel french_about_Label2 = new JLabel(" Systme Rparti Multi-Agents Intelligents", JLabel.CENTER);
		JLabel english_about_Label1 = new JLabel("Remote Working Platform", JLabel.CENTER);
		JLabel english_about_Label2 = new JLabel("using an Intelligent Multi-Agent Distributed System", JLabel.CENTER);
		french_about_Label1.setFont(labelFont);
		french_about_Label2.setFont(labelFont);
		english_about_Label1.setFont(labelFont);
		english_about_Label2.setFont(labelFont);
	
		JPanel labelPane = new JPanel();
		labelPane.setLayout(new GridLayout(5,1));
		labelPane.setBackground(new Color(255,255,255));
		labelPane.setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
		labelPane.add(french_about_Label1);
		labelPane.add(french_about_Label2);
		labelPane.add(Box.createRigidArea(new Dimension(0, 20)));
		labelPane.add(english_about_Label1);
		labelPane.add(english_about_Label2);

		JLabel linux_IconLabel = new JLabel();
		linux_Icon = new ImageIcon(me.getResource(where+"linux_modellingClay.gif"));
	/*
		try {
		Class jarResources=Class.forName("orchid.img.img");
		jarResources.getResource("/linux_modellingClay.gif");
		Image image=Toolkit.getDefaultToolkit().getImage(jarResources.getResource("orchid/gui/gifs/linux_modellingClay.gif"));
		linux_Icon = new ImageIcon(image);
		} catch (Exception e) {System.out.println(e.toString());}
	*/

	/*
		Class me=orchid.gui.about_Window.class;
		URL where=me.getResource("/orchid/img/img.jar/linux_modellingClay.gif");
		ImageIcon linux_Icon = new ImageIcon(where);
	*/
		linux_IconLabel.setIcon(linux_Icon);

		Font authorFont= new Font("SansSerif", Font.PLAIN, 14);
		JPanel authorPane = new JPanel();
		authorPane.setBackground(new Color(255,255,255));
		authorPane.setBorder(BorderFactory.createEmptyBorder(20, 20, 20, 20));
		authorPane.setLayout(new BoxLayout(authorPane, BoxLayout.X_AXIS));
		JTextArea authors_Area= new JTextArea(8,20);
		authors_Area.setText("DARCHE Marc-Aurle \nPIERRE Emmanuel \nSALVY Frdric \nSOULIEZ Antoine \nVARROY Marc-Olivier");
	
		Border authors_Area_border = BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder("ORCHID is being developed by :"), BorderFactory.createEmptyBorder(10, 10, 10, 10));
		authors_Area.setBorder(authors_Area_border);
		authors_Area.setFont(authorFont);
		authors_Area.setForeground(new Color(160,20,0));
		authors_Area.setEditable(false);
		authorPane.add(authors_Area);
		authorPane.add(Box.createRigidArea(new Dimension(10, 0)));
		authorPane.add(linux_IconLabel);
	
		JPanel buttonPane = new JPanel();
		buttonPane.setBackground(new Color(255,255,255));
		JButton ok_button = new JButton("Ok");
		ok_button.setMnemonic('O');
		ok_button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				destroy();
			}
		});

		buttonPane.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		buttonPane.add(ok_button);

		JPanel multiPane = new JPanel();
		multiPane.setBackground(new Color(255,255,255));
		multiPane.setLayout(new BoxLayout(multiPane, BoxLayout.Y_AXIS));
		multiPane.add(authorPane);
		multiPane.add(buttonPane);

		JPanel inside = new JPanel();
		Border raisedbevel = BorderFactory.createRaisedBevelBorder();
		inside.setBorder(raisedbevel);
	
		Container c = getContentPane();
		inside.setLayout(new BorderLayout());
		inside.add(pixPane, BorderLayout.NORTH);
		inside.add(labelPane, BorderLayout.CENTER);
		inside.add(multiPane, BorderLayout.SOUTH);
		c.add(inside);
	
		getRootPane().setDefaultButton(ok_button);
	}//end of init()

	public void start(){
		this.pack();
		this.setLocation(loginWindowLocation);
		//this.setResizable(false);
		this.setVisible(true);
	}

	public void destroy(){
		this.dispose();
	}

}

