package orchid.gui;

import orchid.object.*;
import orchid.agent.*;
import com.objectspace.voyager.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.BorderFactory; 
import javax.swing.border.TitledBorder;

/**
 * Class used to create a Login Window on the client side.<P>
 * @author Marc-Aurle DARCHE
 */
public class LoginWindow extends JFrame {

	String server;
	String userLogin="";
	String userPassword="";

	String identString="";
	Point loginWindowLocation;

	JTextField login_Field;
	JTextField password_Field;
	JButton login_button;
	JLabel alert;

	public LoginWindow() {
		super("ORCHID");
		FileUtil fu= new FileUtil();
		this.server= fu.getServer();
		this.setTitle("ORCHID: //"+server);
	}

	public void init(){
		Font titleFont= new Font("SansSerif", Font.BOLD, 18);
		JLabel title = new JLabel("Welcome to ORCHID", 2);
		title.setForeground(new Color(60,10,120));
		title.setFont(titleFont);

		login_Field = new JTextField(24);
		login_Field.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				password_Field.requestFocus();
			}
		});

		password_Field = new JPasswordField(24);
		password_Field.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				login_button.doClick(); 
			}
		});

		alert =new JLabel("                    ");
		alert.setForeground(new Color(200,0,10));
		JPanel login_Panel = new JPanel();
		login_Panel.setLayout(new FlowLayout());
		JPanel password_Panel = new JPanel();
		password_Panel.setLayout(new FlowLayout());
		JPanel login_PanelP = new JPanel();
		login_PanelP.setLayout(new FlowLayout());
		JPanel password_PanelP = new JPanel();
		password_PanelP.setLayout(new FlowLayout());

		TitledBorder title1 = BorderFactory.createTitledBorder("Enter your Login");
		TitledBorder title2 = BorderFactory.createTitledBorder("Enter your Password");
		Border raisedbevel = BorderFactory.createRaisedBevelBorder();	
		Border loweredbevel = BorderFactory.createLoweredBevelBorder();	
		Border raisedbevel2 = BorderFactory.createRaisedBevelBorder();	
		Border compound1 = BorderFactory.createCompoundBorder(raisedbevel, raisedbevel2);

		login_Panel.setBorder(title1);
		password_Panel.setBorder(title2);
				
		JButton close_button = new JButton("Quit");
		close_button.setMnemonic('q');
		close_button.setToolTipText("Click here to exit");
		close_button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				System.exit(0);
			}
		});
				
		JButton about_button = new JButton("About ORCHID");
		about_button.setMnemonic('a');
		about_button.setToolTipText("Want to know more about ORCHID ?");
		about_button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				AboutWindow aw= new AboutWindow(loginWindowLocation);
				aw.init();
				aw.start();
			}
		});
				
		login_button = new JButton("Login");
		login_button.setMnemonic('l');
		login_button.setToolTipText("Click here to connect to the server");
		login_button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
			userLogin = login_Field.getText();
			userPassword = password_Field.getText();
			System.out.println("Login: "+userLogin+" and Password: "+userPassword);
			String temp=userLogin+"_";
			try{
				ISaa sa1 = (ISaa) Namespace.lookup("//"+server+"/SAA");
				identString=temp+sa1.getAuthentication(userLogin,userPassword);
				if (identString.equals("")) {alert.setText("Wrong Login or Password !");}
				else {
					alert.setText("Connected ...");
					/*
					ButtonBarWindow bbw= new ButtonBarWindow(identString,loginWindowLocation);
					bbw.init();
					bbw.start();
					*/
					destroy();
				}
			} catch (Exception ve) {
				identString=temp;
				alert.setText("Network Exception !");
				System.err.println(" -- LoginWindow.class: Trying to reach //"+server+"/SAA proxy for authentication >>> "+ve);
			  }
			System.out.println("Your identString is: "+identString);
			//*
			alert.setText("This is a test -- Not Connected !");
			ButtonBarWindow bbw= new ButtonBarWindow(identString,loginWindowLocation);
			bbw.init();
			bbw.start();
			//*/
			}
		});
        
		JPanel listPane = new JPanel();
		listPane.setLayout(new BoxLayout(listPane, BoxLayout.Y_AXIS));
		listPane.add(Box.createVerticalGlue());
		listPane.add(title);
		listPane.add(Box.createRigidArea(new Dimension(0,10)));
		listPane.add(Box.createVerticalGlue());
		login_Panel.add(login_Field);
		login_PanelP.add(login_Panel);
		listPane.add(login_PanelP);
		password_Panel.add(password_Field);
		password_PanelP.add(password_Panel);
		listPane.add(password_PanelP);
		JPanel alertPane = new JPanel();
		alertPane.setForeground(new Color(160,20,0));
		alertPane.add(alert);
		listPane.add(alertPane);
		listPane.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
	
		JPanel buttonPane = new JPanel();
		buttonPane.setLayout(new BoxLayout(buttonPane, BoxLayout.X_AXIS));
		buttonPane.setBorder(BorderFactory.createEmptyBorder(0, 20, 20, 20));
		buttonPane.add(Box.createHorizontalGlue());
		buttonPane.add(close_button);
		buttonPane.add(Box.createRigidArea(new Dimension(10,0)));
		buttonPane.add(about_button);
		buttonPane.add(Box.createRigidArea(new Dimension(10,0)));
		buttonPane.add(login_button);

		JPanel inside = new JPanel();
		Container c = getContentPane();
		inside.setLayout(new BorderLayout());
		inside.add(listPane, BorderLayout.CENTER);
		inside.add(buttonPane, BorderLayout.SOUTH);
		inside.setBorder(compound1);   
		c.add(inside);
		getRootPane().setDefaultButton(login_button);
		login_Field.requestFocus();
        
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e){
				System.exit(0);
			}
		});
	}//end of init()

	public void start(){
		this.pack();
		loginWindowLocation= new Point();
		loginWindowLocation.translate(20,140);
		this.setLocation(loginWindowLocation);
		this.setVisible(true);
		// to get getLocationOnScreen() the component has first to be visible !
		this.addComponentListener(new ComponentAdapter() {
			public void componentMoved(ComponentEvent e){
				loginWindowLocation.setLocation(getLocationOnScreen());
			}
		});
		login_Field.requestFocus();
	}

	public void destroy(){
		this.dispose();
	}

}//end of public class LoginWindow

