package orchid.gui;

// les autres packages de orchid
import orchid.object.*;
import orchid.agent.*;
// voyager
import com.objectspace.voyager.*;
// librairies swing java 1.2
import javax.swing.*;
//librairies java standard
import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.util.Calendar;
import java.util.Vector;

/**
 * A class used to display a Perpetual Calendar using Swing Components.<BR>
 * @see Calculation
 * @author Frdric Salvy
*/
public class MeetingAgentWindow extends JFrame implements ActionListener {

	Class me= this.getClass();
	String where="/orchid/img/";
	//String where="../img/"; should also work, but it's better to use the line above.
	Image icone=getToolkit().getImage(me.getResource(where+"orchidIcon.gif"));

 	String identString;
	String username="";
	String server;
 	Vector mList=new Vector();
	Meeting meet;


	Point buttonBarWindowLocation;
	Point meetingAgentWindowLocation;
	CallMeetingWindow cmw;
	Date beginningDate=new Date();
 
	final JTabbedPane tabbedPane=new JTabbedPane();
	JTextArea textPaneNote;
	ImageIcon left_a = new ImageIcon(me.getResource(where+"left_arrow.gif"));
	ImageIcon right_a = new ImageIcon(me.getResource(where+"right_arrow.gif"));


	// les 31 jours du mois (numros)
	String[] day_num = new String[31];
	JButton[] but;
	int prev_click=0;
	int index=0;
	Color defaultcolor;
	// les jours de la semaine
	String day_name[]={"Mon","Tue","Wed","Thu","Fri","Sat","Sun"};
	// les 12 mois
	String month[]={"Janua","Febru","March"," April ","  May  "," June ",
									"  July  ","Agust","Septe","Octob","Novem","Decem"};

	// gestion des dates calendrier
	int currMonth=0;
	int nbDays;
	int selectedTab=1;
	int selectedMonth;
	JTextField currYear;

	// liens avec classes externes
	Calculation cal=new Calculation();
	TableWork tableWork=new TableWork();
	JTable table= tableWork.init();
	Dimension window_Dimension=new Dimension(50,50);


	// listeners...listeners...listeners...listeners...listeners...
		// commandes pour la navigation
		final String fForw="fastForward";
		final String forw="Forward";
		final String fBack="fastBackward";
		final String back="Backward";
		final String cYear="CurrentYear";
		// commandes pour les onglets next&prev
		final String CNext="Next";
		final String CPrev="Preview";
		
		// commandes pour les 31 boutons...
		String[] CB=new String[31];
		// commandes pour la mainNavigation
		final String dismiss="Dimiss";
		final String callmeeting="CallMeeting";
		final String viewrequests="ViewRequests";


	// le constructeur
	public MeetingAgentWindow(String identString, Point buttonBarWindowLocation) {
		super("MeetingAgent Window");
		this.identString=identString;
		this.server= Util.getServer();
		this.buttonBarWindowLocation=buttonBarWindowLocation;
		if ( (identString.length()>0) && (identString.indexOf("_")>0) ) this.username=identString.substring(0,identString.indexOf("_"));
		System.out.println("My username is: "+username);
	}

	public void init(){
	// l'icne de l'appli
	this.setIconImage(icone);

	// les 31 jours du mois
	for (int j = 0; j <31 ; j++) { day_num[j]=""+(j+1) ; }
	// les 31 boutons   (listener)
	for (int j = 0; j <31 ; j ++) { CB[j]= "c"+j; }

	/*
	Structure graphique :

	JFrame frame
	|
	+-- Jpanel main
			|
			+-- Jpanel main2
					|
					+-- Jpanel mainLeft
             +--  JPanel navigation
                  +--- JButton fastBackward
                  +--- JButton Backward
                  +--- JTextField currYear
                  +--- JButton Forward
                  +--- JButton fastForward
             +--  JTabbedPane tabbedPane
                  +-- onglet Preview
                  +-- onglets pour 4 mois de l'anne
                      +--- 7 JTextField pour les jours de la semaine
                      +-- 31 JButton but[j]
                  +-- onglet Next
             +--  JPanel barre_date
           |
           +-- Jpanel mainRight
              +-- JPanel agenda
              +-- JTable table
              +-- JPanel panelNote
      |
      +--- Jpanel mainNagivaton
         +--- JButton DismissAgent
         +--- JButton CallForAMeeting
         +--- JButton ViewRequests
         +--- JButton Nav4
  */

	
	// constuction des panels

		// panel englobant  (niveau 0)
		JPanel main = new JPanel();
		main.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		
		// panels de 1er niveau
		JPanel main2 = new JPanel();
		JPanel mainNavigation = new JPanel();
		mainNavigation.setBorder(BorderFactory.createTitledBorder(""));
			JButton Dismiss = new JButton("Dismiss Meeting Agent");
			JButton CallMeeting = new JButton("Call For A Meeting");
			JButton ViewRequests = new JButton("View Meeting Requests");

		// panels de 2eme niveau
		JPanel mainLeft = new JPanel();
		JPanel mainRight = new JPanel();
		mainRight.setBorder(BorderFactory.createEmptyBorder(0,10,10,10));
		
		// Panels de 3eme niveau
		
		// Left...Left...Left...Left...Left...Left...Left...Left...
			// les boutons de selection d'anne
			JPanel navigation0 = new JPanel(false);
			navigation0.setLayout(new GridLayout(0,1));
			navigation0.setBorder(BorderFactory.createTitledBorder("Navigation"));
			JPanel navigation = new JPanel(false);
			 
			 // les icnes
			 ImageIcon backward_img = new ImageIcon(me.getResource(where+"backward.gif"));
			 ImageIcon fastbackward_img = new ImageIcon(me.getResource(where+"fastbackward.gif"));
			 ImageIcon forward_img = new ImageIcon(me.getResource(where+"forward.gif"));
			 ImageIcon fastforward_img = new ImageIcon(me.getResource(where+"fastforward.gif"));
			 // les boutons
			 JButton fastBack = new JButton("",fastbackward_img);
			 JButton bacward = new JButton("",backward_img);
			 JButton forward = new JButton("",forward_img);
			 JButton fastForw = new JButton("",fastforward_img);

			// le calendrier

				// click sur les onglets <- et ->
				tabbedPane.addMouseListener(new MouseAdapter() {
					public void mouseClicked(MouseEvent e) {
						// click sur ->
						if (tabbedPane.getSelectedIndex()==5) {
							currMonth=(currMonth+1) % 12;
							tabbedPane.removeAll();
							DisplayTabb(selectedTab,currMonth,0);
						}
						// click sur <-
						if (tabbedPane.getSelectedIndex()==0) {
							currMonth=(currMonth+11) % 12;
							tabbedPane.removeAll();
							DisplayTabb(selectedTab,currMonth,0);
						}
					OnTimeDisplay(tabbedPane);
					}
				});

		// Right...Right...Right...Right...Right...Right...Right...
			// l'agenda
			JPanel agenda=new JPanel();
			agenda.setBorder(BorderFactory.createTitledBorder("Agenda"));
			JScrollPane agendascroll = new JScrollPane(table);
			table.setPreferredScrollableViewportSize(new Dimension(360,200));
			
			table.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					javax.swing.table.TableModel model = table.getModel();
					int clicked_row=table.getSelectedRow();
					System.out.println("click sur la ligne n "+clicked_row);
					
					// les autres colonnes
  				for (int num=0;num<mList.size();num++) {
						meet=(Meeting) mList.elementAt(num);
						int heure_meet=meet.getTimeOfDay();

						int min_meet=heure_meet % 100;
						heure_meet=heure_meet / 100;
						//ordonnee dans la table
						heure_meet=(heure_meet-8)*2;
						if (min_meet==30) min_meet=1; else min_meet=0;
					 System.out.println("ordonnee du rdv "+(int)(heure_meet+min_meet));
						

						int heure_dur=meet.getDuration();
						int min_dur=heure_dur % 100;
						heure_dur=heure_dur / 100;

						//nbre de cases de la duree
						heure_dur=heure_dur*2;
						if (min_dur==30) min_dur=1; else min_dur=0;

					 System.out.println("nbre cases de la duree "+(int)(heure_dur+min_dur));
					 if ((clicked_row>=heure_meet+min_meet) && (clicked_row<=heure_meet+min_meet+heure_dur+min_dur)) {
					 System.out.println("affichage de la note "+ num);
					 meet=(Meeting) mList.elementAt(num);
					 textPaneNote.setText("");
					 textPaneNote.append("Subject : "+meet.getSubject()+"\n");
					 textPaneNote.append("Notes : "+meet.getNote()+"\n");
					 textPaneNote.append("Initiator : "+meet.getInitiator()+"\n");
					 textPaneNote.append("Time of day : "+meet.getTimeOfDay()+"\n");
					 textPaneNote.append("Duration : "+meet.getDuration()+"\n");
					 textPaneNote.append("Participants : "+meet.getParticipants()+"\n");
					 if (meet.getFrozen()==true) textPaneNote.append("Meeting Frozen !");
					 else textPaneNote.append("Meeting *not* Frozen yet !");
					}	
				//	tableWork.printDebugData(table);
				}
			}});
			agenda.add(agendascroll);

			//le panel de Note
			textPaneNote = new JTextArea(10,20);
			textPaneNote.setEditable(false);
			textPaneNote.setCaretPosition(0);
			textPaneNote.setMargin(new Insets(5,5,5,5));
			JScrollPane scrollPaneNote = new JScrollPane(textPaneNote);
			
			JPanel panelNote = new JPanel();
			panelNote.setLayout(new BoxLayout(panelNote, BoxLayout.Y_AXIS));
			panelNote.setBorder(BorderFactory.createTitledBorder("Notes"));
			panelNote.add(scrollPaneNote);

			// la barre_date
			JPanel barre_date = new JPanel(false);
			//la date courante
			Calculation calDayTime= new Calculation();
			String sHour=Integer.toString( calDayTime.getTodayTimeHour());
			String sMin=Integer.toString(calDayTime.getTodayTimeMinute());
			String sSec=Integer.toString(calDayTime.getTodayTimeSecond());
			String sDay=Integer.toString(calDayTime.getTodayDay());
			String sMonth=Integer.toString(calDayTime.getTodayMonth());
			String sYear=Integer.toString(calDayTime.getTodayYear());
			JTextField currTime =new JTextField(sDay+"/"+sMonth+"/"+sYear+"   "+sHour+":"+sMin+":"+sSec);
			currTime.setEditable(false);
			currTime.setHorizontalAlignment(JTextField.CENTER);
			currTime.addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent e) {
					setDisplayToCurrentTime();
				}   
			});

		
			barre_date.add(currTime);
		currYear = new JTextField(sYear);

	// les marges
	Insets Margin=new Insets(2,20,2,20);
	currTime.setMargin(Margin); currYear.setMargin(Margin);
	fastBack.setMargin(Margin); fastForw.setMargin(Margin);
	bacward.setMargin(Margin); forward.setMargin(Margin);


	// les listeners...les listeners...les listeners...les listeners...les listeners...
	navigation.add(fastBack); fastBack.setActionCommand(fBack);fastBack.addActionListener(this);
	navigation.add(bacward); bacward.setActionCommand(back); bacward.addActionListener(this);
	navigation.add(currYear); currYear.setActionCommand(cYear); currYear.addActionListener(this);
	navigation.add (forward); forward.setActionCommand(forw);  forward.addActionListener(this);
	navigation.add (fastForw); fastForw.setActionCommand(fForw); fastForw.addActionListener(this);
 
 
 mainNavigation.add (CallMeeting);CallMeeting.setActionCommand(callmeeting); CallMeeting.addActionListener(this);
 mainNavigation.add(ViewRequests);ViewRequests.setActionCommand(viewrequests);  ViewRequests.addActionListener(this);
 mainNavigation.add(Dismiss);Dismiss.setActionCommand(dismiss); Dismiss.addActionListener(this);

	// remplissage de la Jframe
	navigation0.add(navigation);
	navigation0.add(barre_date);
	
	mainLeft.setLayout(new BoxLayout(mainLeft, BoxLayout.Y_AXIS));
	mainLeft.add(navigation0);
	mainLeft.add(tabbedPane);

	mainRight.setLayout(new BoxLayout(mainRight, BoxLayout.Y_AXIS));
	mainRight.add(agenda);
	mainRight.add(panelNote);

	main2.setLayout(new GridLayout(1,1));
	main2.add(mainLeft);
	main2.add(mainRight);

	main.setLayout(new BoxLayout(main, BoxLayout.Y_AXIS));
	main.add(main2);
	main.add(mainNavigation);

	getContentPane().add(main);
	setDisplayToCurrentTime();

 }//end of init()
 
	public void setDisplayToCurrentTime() {
		// 1er affichage lors de l'initialisation
		Calculation calDay= new Calculation();
		int year= calDay.getTodayYear();
		currMonth=calDay.getTodayMonth();
		int currDay=calDay.getTodayDay();
		selectedTab=currMonth;

		// quel jour tombe le 1er du mois courant ?
		int day1= calDay.setTime(1,currMonth,year);
		// nbres de jours du mois courant
		nbDays=calDay.getNbOfDayInMonth(currMonth,year);
		// quand tous les params sont connus, affichage
		currYear.setText(""+year);
		DisplayTabb(1,currMonth,day1-1);
		OnTimeDisplay(tabbedPane);
		but[currDay-1].doClick();
		ReInit(table);
	}

 public void ReInit(JTable table) {
	try{
		IMeetingAgent ma = (IMeetingAgent) Namespace.lookup("//"+server+"/ma__"+username);
		mList=ma.getMeetings(beginningDate,beginningDate);
	} catch (Exception ve) { System.err.println(ve); }


	// MAJ de la table
	int nbcol = table.getColumnCount();
	String demi="";
	int hour=7;
	// que les heures
	javax.swing.table.TableModel model = table.getModel();
	for (int ligne=0;ligne<28;ligne++) {
		if (ligne %2==0) {demi="00"; hour++;}
		else {demi="30";}
		model.setValueAt(hour+"h"+demi,ligne,0);
		for (int col=0;col<nbcol-1;col++) {
			model.setValueAt("",ligne,col+1);
		}
	}

	// les autres colonnes
	for (int num=0;num<mList.size();num++) {
		meet=(Meeting) mList.elementAt(num);
		System.out.println("date de rdv : "+meet.getDate());
		int heure_meet=meet.getTimeOfDay();
		System.out.println("heure de rdv : "+heure_meet);
		
		int min_meet=heure_meet % 100;
		heure_meet=heure_meet / 100;
	
		int heure_dur=meet.getDuration();
		System.out.println("duration de rdv : "+heure_dur);
		
		int min_dur=heure_dur % 100;
		heure_dur=heure_dur / 100;
	
		System.out.println("nvlle heure de rdv : "+heure_meet);
		System.out.println("min de rdv : "+min_meet);
		if (min_meet==30) min_meet=1; else min_meet=0;
		
		
		System.out.println("subject: "+meet.getSubject());
		
		
		if (min_dur==30) min_dur=1; else min_dur=0;
		System.out.println("dure totale en case: "+(int) (heure_dur+min_dur));
		for (int i=0;i<2*heure_dur+min_dur;i++) {
			model.setValueAt(meet.getSubject(),(heure_meet-8)*2+min_meet+i,1);
			model.setValueAt(meet.getInitiator(),(heure_meet-8)*2+min_meet+i,2);
		}
		
		System.out.println("initiator : "+meet.getInitiator());
		System.out.println("heure du jour : "+meet.getTimeOfDay());
		System.out.println("participants : "+meet.getParticipants());
		System.out.println("frozen : "+meet.getFrozen());
		System.out.println("note : "+meet.getNote());
		System.out.println("");
	}
 
 }// end of ReInit
 
	public void OnTimeDisplay(JTabbedPane tabbedPane) {
  // onglet selectionn
  selectedTab=tabbedPane.getSelectedIndex();
  // mois selectionn
  selectedMonth=selectedTab+currMonth-1;
	System.out.println("selectedMonth : "+ selectedMonth);
	System.out.println("selectedTab : "+selectedTab);
  // quel jour tombe le 1er du mois et de l'anne courants ?
  Calculation calDay= new Calculation();
  Integer temp=Integer.valueOf(currYear.getText());
  int temp2=temp.intValue();
  int day= calDay.setTime(1,selectedMonth,temp2);
  // nbres de jours du mois courant
  nbDays=calDay.getNbOfDayInMonth(selectedMonth,temp2);
  // quand tous les params sont connus, affichage
  tabbedPane.removeAll();
  DisplayTabb(selectedTab,currMonth,day-1);
 }// end of     OnTimeDisplay

 public void DisplayTabb(int selected,int currMonth, int offset) {
  if (selected==1) {
   Component panel1 = new JPanel(false);
   tabbedPane.addTab("", left_a, panel1, "Preview Month");
   Component panel2 = makeCalPanel(day_name,day_num,offset);
   tabbedPane.addTab(month[currMonth], null, panel2, "Select Current Month");
   Component panel3 = new JPanel(false);
   tabbedPane.addTab(month[(currMonth+1) % 12], null, panel3, "Select Current Month");
   Component panel4 = new JPanel(false);
   tabbedPane.addTab(month[(currMonth+2) % 12], null, panel4, "Select Current Month");
   Component panel5 = new JPanel(false);
   tabbedPane.addTab(month[(currMonth+3) % 12], null, panel5, "Select Current Month");
   Component panel6 = new JPanel(false);
	 tabbedPane.addTab("", right_a, panel6, "Next Month");
  }

  if (selected==2) {
	 Component panel1 = new JPanel(false);
	 tabbedPane.addTab("", left_a, panel1, "Preview Month");
   Component panel2 =new JPanel(false);
	 tabbedPane.addTab(month[currMonth], null, panel2, "Select Current Month");
	 Component panel3 = makeCalPanel(day_name,day_num,offset);
   tabbedPane.addTab(month[(currMonth+1) % 12], null, panel3, "Select Current Month");
 	 Component panel4 = new JPanel(false);
   tabbedPane.addTab(month[(currMonth+2) % 12], null, panel4, "Select Current Month");
 	 Component panel5 =new JPanel(false);
   tabbedPane.addTab(month[(currMonth+3) % 12], null, panel5, "Select Current Month");
	 Component panel6 = new JPanel(false);
	 tabbedPane.addTab("", right_a, panel6, "Next Month");
  }

  if (selected==3) {
	 Component panel1 = new JPanel(false);
	 tabbedPane.addTab("", left_a, panel1, "Preview Month");
   Component panel2 = new JPanel(false);
	 tabbedPane.addTab(month[currMonth], null, panel2, "Select Current Month");
	 Component panel3 = new JPanel(false);
   tabbedPane.addTab(month[(currMonth+1) % 12], null, panel3, "Select Current Month");
 	 Component panel4 = makeCalPanel(day_name,day_num,offset);
   tabbedPane.addTab(month[(currMonth+2) % 12], null, panel4, "Select Current Month");
 	 Component panel5 =new JPanel(false);
   tabbedPane.addTab(month[(currMonth+3) % 12], null, panel5, "Select Current Month");
	 Component panel6 = new JPanel(false);
	 tabbedPane.addTab("", right_a, panel6, "Next Month");
  }

  if (selected==4) {
	 Component panel1 = new JPanel(false);
	 tabbedPane.addTab("", left_a, panel1, "Preview Month");
   Component panel2 = new JPanel(false);
   tabbedPane.addTab(month[currMonth], null, panel2, "Select Current Month");
	 Component panel3 = new JPanel(false);
   tabbedPane.addTab(month[(currMonth+1) % 12], null, panel3, "Select Current Month");
 	 Component panel4 =new JPanel(false);
   tabbedPane.addTab(month[(currMonth+2) % 12], null, panel4, "Select Current Month");
 	 Component panel5 = makeCalPanel(day_name,day_num,offset);
   tabbedPane.addTab(month[(currMonth+3) % 12], null, panel5, "Select Current Month");
	 Component panel6 = new JPanel(false);
	 tabbedPane.addTab("", right_a, panel6, "Next Month");
  }

  // par dfault, l'onglet actif est selectionn
  tabbedPane.setSelectedIndex(selectedTab);
 } // end of DisplayTabb


 // construction des boutons du mois courant
 public Component makeCalPanel(String[] day_name,
                                String[] day_num, int num_offset) {
  // le panel ou l'on ecrit
  JPanel panel = new JPanel(false);

  // les jours de la semaine
  for (int j = 0; j <day_name.length ; j ++) {
   JTextField textField = new JTextField(day_name[j]);
   textField.setEditable(false);
   textField.setHorizontalAlignment(JTextField.CENTER);
   panel.add(textField);
  }

  // les numros des jours avec dcalage pour le 1er du mois
  for (int j = 0; j <num_offset ; j ++) {
   panel.add(Box.createRigidArea(new Dimension(5,0)));
  }
  but=new JButton[nbDays];
  for (int j = num_offset; j <nbDays+num_offset ; j ++) {
   but[j-num_offset] = new JButton(day_num[j-num_offset]);
  }

  // ajout de tous les boutons du panel
  for (int j = 0; j < nbDays; j ++) {
 	 panel.add(but[j]);
   but[j].setActionCommand(CB[j]);
   but[j].addActionListener(this);
   Insets Margin=new Insets(1,1,1,1);
   but[j].setMargin(Margin);
  }
  defaultcolor=but[0].getBackground();
  for (int j = nbDays; j <nbDays+8-num_offset ; j ++) {
   panel.add(Box.createRigidArea(new Dimension(5,0)));
  }
  // mise en page
  panel.setLayout(new GridLayout(0, 7));
  return panel;
 } // end of makeCalPanel
  
 // listener action
 public void actionPerformed(ActionEvent e) {
  String command = e.getActionCommand();

  // navigation
  if (command==fForw)  {
   Integer temp=Integer.valueOf(currYear.getText());
   int temp2=temp.intValue()+5;
   currYear.setText(Integer.toString(temp2));
   OnTimeDisplay(tabbedPane);
  }
  if (command==forw) {
   Integer temp=Integer.valueOf(currYear.getText());
   int temp2=temp.intValue()+1;
   currYear.setText(Integer.toString(temp2));
   OnTimeDisplay(tabbedPane);
  }
  if (command==fBack) {
   Integer temp=Integer.valueOf(currYear.getText());
   int temp2=temp.intValue()-5;
   currYear.setText(Integer.toString(temp2));
   OnTimeDisplay(tabbedPane);
  }
  if (command==back) {
   Integer temp=Integer.valueOf(currYear.getText());
   int temp2=temp.intValue()-1;
   currYear.setText(Integer.toString(temp2));
   OnTimeDisplay(tabbedPane);
  }

	
	// les 31 boutons
  if (command.substring(0,1).equals("c")) {
          prev_click=index;
   try {
    index=new Integer(command.substring(1)).intValue();

        System.out.println(index+1);
        but[index].setBackground(new Color(255,150,100));
				if (index != prev_click) {
					but[prev_click].setBackground(defaultcolor);
					prev_click=index;
				}
				Calendar calendar = Calendar.getInstance();
				 Integer temp=Integer.valueOf(currYear.getText());
				    int year=temp.intValue();
						
				calendar.set(year,selectedMonth,index+1,0,0,0); 
				beginningDate=calendar.getTime();
				System.out.println(beginningDate);
            textPaneNote.setText("");
				ReInit(table);

    }
   catch (Exception a) {a.getMessage();System.out.println(command);}
  }

  // barre_bas
  if (command==callmeeting) {
   cmw= new CallMeetingWindow(identString,meetingAgentWindowLocation);
   cmw.init();
   cmw.start();
  }
  if (command==dismiss) {
   try{cmw.destroy();} catch (Exception exc){}
   destroy();
  }
  if (command==viewrequests) {
   System.out.println("viewrequests");
  }

 }// end of actionPerformed





	public void start(){
		this.pack();
		meetingAgentWindowLocation= new Point();
		meetingAgentWindowLocation.setLocation(buttonBarWindowLocation);
		meetingAgentWindowLocation.translate(180,0);
		this.setLocation(meetingAgentWindowLocation);
		this.setVisible(true);
	}

	public void destroy(){
		this.dispose();
	}

	static public void main(String args[]){
		Point p= new Point();
		MeetingAgentWindow maw= new MeetingAgentWindow("anUntrueIdentification_anUntrueIdentification",p);
		maw.init();
		maw.start();
	}

}// end of class MeetingAgentWindow

